#! /bin/sh
#
# Show a condensed CVS revision list
#
myname=`basename $0`
#
format=0
#
case "$#" in
	1) file="$1"
	   shift
	   ;;
	2) shift
	   file="$1"
	   format=1
	   shift
	   ;;
	*) echo "Usage: $myname [-b] file" 1>&2 
	   exit 1
	   ;;
esac
#
#
cvs log $file | awk '
{
  if ( $1 == "symbolic")
    {
      tags = 1;
      next;
    }

  if (tags)
    {
      if ( $1 == "keyword" )
	{
	  tags = 0;
	}
      else
	{
	  i = index ($1, ":");
	  tag[$2] = tag[$2] " " substr ($1, 1, i-1);
	}
    }
    
  if ( $1 == "revision" )
    {
      revision = $2;
    }

  if ( $1 == "branches:" )
    {
      split ($2, b, ";");
      branches++;
      branch[branches] = b[1];
    }

  if ( $1 == "date:")
    {
      n = split ($2, ymd, "/");
      date = ymd[2] "/" ymd[3] "/" ymd[1];
      n = split ($3, hms, ";");
      time = hms[1] " GMT";

      if ( '"$format"' == "1" )
	print date " " time " " revision " " tag[revision];
      else
	print date " " time ";" revision ";" tag[revision] ";";
    }
}'

