#!/bin/csh -f

#---------------------------------------------------------
#alias db $DBROOT/`pck system`/db.exe
#
#if ( $#argv != 0 ) then
#  setenv DBDOMAIN $1
#endif
#
#if ( $?DBDOMAIN == 0 ) then
#  db domains
#else
#  eval `db set_domain $DBDOMAIN`
#  echo 'The domain '$DBDOMAIN' is now defined'
#endif
#---------------------------------------------------------

alias show_domains "echo '# The available domains are defined in $DBROOT/mgr/DbDomains : '; \
 echo '# '; \
 grep -v '^#' ${DBROOT}/mgr/DbDomains | sed 's#[ ].*##' "

if ( "$1" == "" ) then
  if ( $?DBDOMAIN ) then
    set domain = ( ${DBDOMAIN} )
  else
    echo "# You should define a domain name, either as the argument"
    echo "# to this procedure, or as the DBDOMAIN environment variable."
    show_domains
    exit 1
  endif
else
  set domain = ( $1 )
endif

set line = ( `grep -e "^${domain}[ ]" $DBROOT/mgr/DbDomains` )

if ( "$line" != "" ) then
  setenv DBDOMAIN      ${domain}
  setenv CMDOMAIN      `echo $line | cut -d' ' -f2`
  setenv DBSERVERNAME  `echo $line | cut -d' ' -f3`
  setenv DBOBJECTSROOT `echo $line | cut -d' ' -f4`
  setenv DBCVSROOT     `echo $line | cut -d' ' -f5`
  echo "# The domain ${domain} is now configured."
  exit 0
else
  echo "# The domain $domain is not defined in the DbDomains file."
  show_domains
  exit 1
endif
