#ifndef lint
static char const 
DbYYrcsid[] = "$FreeBSD: src/usr.bin/yacc/skeleton.c,v 1.28 2000/01/17 02:04:06 bde Exp $";
#endif
#include <stdlib.h>
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYLEX DbYYlex()
#define YYEMPTY -1
#define DbYYclearin (DbYYchar=(YYEMPTY))
#define DbYYerrok (DbYYerrflag=0)
#define YYRECOVERING() (DbYYerrflag!=0)
static int DbYYgrowstack();
#define YYPREFIX "DbYY"

/*-- Include files ----------------------------------------------*/
#include <stdarg.h>
#include <ctype.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#define alloca malloc
/*---------------------------------------------------------------*/

/*---------------------------------------------------------------*/
#include <Db.h>
/*---------------------------------------------------------------*/


/*-- Prototypes -------------------------------------------------*/
#define DbYYparse DbSemanticAnalyzer
#define DbYYerror DbLexicalError
#define DbYYerrlab DbErrLbl
#define DbYYerrflag DbErrFlg

int DbSemanticAnalyzer ();
int DbYYlex ();

typedef enum
{
  ObjectHead,
  ObjectCopy
} ParserMode;

typedef struct
{
  DbVersioningOption option;
  ParserMode       mode;
  DbObject         first_object;
  DbObject         object;
  DbType           type;
  DbTypeIterator   type_iterator;
  CLList           objects;  /* For multiple object definition */
  char*            name;
} ParserContext;

typedef struct
{
  char* buffer;
  int length;
  int current_position;
  int line_number;
  char* old_line_start;
  char* line_start;
} LexContext;

static ParserContext* Context = NULL;
static LexContext*    Lex_context = NULL;
 
int DbLexLineNumber ();
char* DbLexLineStart ();
int DbLexPos ();
void DbLexRestoreContext (LexContext* context);
LexContext* DbLexStartup (LexContext* context, char* text);

static int DbLexicalError(char* s);

static void ContextSetName (ParserContext* context, char* name);
static void ContextAppendName (ParserContext* context, char* name);
/*---------------------------------------------------------------*/
typedef union
{
  DbVersioningOption option;
  CLList      list;
  DbObject    object;
  DbType      type;
  double      real;
  int         number;
  char*       string;
} YYSTYPE;
#define YYERRCODE 256
#define OPEN_SQUARE 257
#define CLOSE_SQUARE 258
#define OPEN_BRACE 259
#define CLOSE_BRACE 260
#define OPEN_PAR 261
#define CLOSE_PAR 262
#define LOWER 263
#define GREATER 264
#define COMMA 265
#define EQUAL 266
#define SLASH 267
#define SHORT 268
#define INT 269
#define HEXA 270
#define FLOAT 271
#define DOUBLE 272
#define CHARACTER 273
#define STRING 274
#define REFERENCE 275
#define VERSION 276
#define NOVERSION 277
#define AT 278
#define NAME 279
#define TEXT 280
#define REAL 281
#define NUMBER 282
const short DbYYlhs[] = {                                        -1,
    0,    0,    9,    9,    6,    6,    4,   11,    4,    8,
    8,    8,    7,    7,    5,    1,    1,    1,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    3,    3,
    3,    3,   10,   10,   12,   12,   13,   13,   13,   13,
   16,   13,   13,   17,   14,   15,   15,   18,   18,
};
const short DbYYlen[] = {                                         2,
    0,    1,    1,    2,    1,    3,    1,    0,    4,    0,
    3,    3,    0,    2,    4,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    4,    1,    3,    7,
    7,    4,    0,    1,    1,    1,    1,    1,    1,    1,
    0,    4,    3,    0,    4,    0,    1,    1,    2,
};
const short DbYYdefred[] = {                                      0,
    0,    0,    3,    0,    0,    0,    0,    0,    8,   18,
   20,   21,   22,   23,   24,   19,   25,    0,   28,    0,
    0,   17,    4,   11,   12,    0,    0,    5,    0,    0,
    0,    0,   39,   38,   37,    0,    9,   34,   35,   36,
    0,    0,    0,   15,    0,   29,    0,    0,    0,    0,
   44,   27,    6,   14,   32,    0,    0,   43,   48,    0,
    0,    0,    0,    0,   42,   49,   45,    0,    0,   31,
   30,
};
const short DbYYdgoto[] = {                                       2,
   20,   21,   22,    3,    4,   36,   44,    5,    6,   37,
   26,   38,   39,   40,   60,   50,   62,   61,
};
const short DbYYsindex[] = {                                   -254,
 -271,    0,    0, -258, -252, -254, -251, -247,    0,    0,
    0,    0,    0,    0,    0,    0,    0, -226,    0, -267,
 -218,    0,    0,    0,    0, -246, -217,    0, -264, -256,
 -214, -223,    0,    0,    0, -227,    0,    0,    0,    0,
 -205, -219, -215,    0, -197,    0, -193, -192, -191, -246,
    0,    0,    0,    0,    0, -190, -189,    0,    0, -188,
 -246, -235, -210, -209,    0,    0,    0, -184, -183,    0,
    0,
};
const short DbYYrindex[] = {                                     90,
    0,    0,    0,   70,    0,  110,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, -216,    0,    0,
 -203,    0,    0,    0,    0,  130,    0,    0,   50,    0,
 -250,    1,    0,    0,    0,   28,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, -182,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 -181,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,
};
const short DbYYgindex[] = {                                      0,
    0,   53,    0,   71,    0,   61,    0,    0,    0,    0,
    0,  -12,   20,    0,    0,    0,    0,    0,
};
#define YYTABLESIZE 405
const short DbYYtable[] = {                                      45,
    5,   46,   42,   10,    7,    8,    1,    9,   41,   41,
   24,   28,   31,   43,   25,   11,   12,   13,   14,   15,
   16,   17,   18,   31,   47,   48,   19,   40,   41,   41,
   41,   41,   32,   33,   34,   35,   27,   59,   30,   42,
   26,   49,   51,   28,   33,   34,   35,   26,   66,   13,
   11,   12,   13,   14,   15,   16,   17,   18,   52,   53,
   55,   19,   26,   54,   56,   57,   63,   64,   58,    7,
   68,   65,   69,   70,   71,   16,   23,   46,   47,   41,
   29,   67,    0,    0,    0,    0,    0,    0,    0,    1,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    2,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   33,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    5,    0,    0,    5,
    5,    5,    0,    0,    0,    0,    0,    5,    5,    5,
    5,    5,    5,    5,    5,    5,    0,    0,    0,    5,
    5,    5,    5,   40,    0,    0,   40,   40,   40,    0,
    0,    0,    0,    0,    0,   40,   40,   40,   40,   40,
   40,   40,   40,    0,    0,   13,   40,   40,   40,   40,
   13,    0,    0,    0,    0,   13,    0,   13,   13,   13,
   13,   13,   13,   13,   13,    7,    0,    0,   13,    0,
    7,    0,    0,    0,    0,    0,    0,    7,    7,    7,
    7,    7,    7,    7,    7,   10,    0,    0,    7,    0,
    0,    0,    0,    0,    0,    0,    0,   10,   10,   10,
   10,   10,   10,   10,   10,   10,    0,    0,   10,    0,
    0,    0,    0,    0,    0,    0,    0,   10,   10,   10,
   10,   10,   10,   10,   10,   33,    0,    0,   10,    0,
   33,    0,    0,    0,    0,    0,    0,   33,   33,   33,
   33,   33,   33,   33,   33,
};
const short DbYYcheck[] = {                                     256,
    0,  258,  267,  256,  276,  277,  261,  266,  259,  260,
  262,  279,  259,  278,  262,  268,  269,  270,  271,  272,
  273,  274,  275,  259,  281,  282,  279,    0,  279,  280,
  281,  282,  279,  280,  281,  282,  263,   50,  257,  267,
  257,  256,  266,  279,  280,  281,  282,  264,   61,    0,
  268,  269,  270,  271,  272,  273,  274,  275,  264,  279,
  258,  279,  279,  279,  258,  258,  257,  257,  260,    0,
  281,  260,  282,  258,  258,  279,    6,  260,  260,   27,
   20,   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  256,   -1,   -1,  259,
  260,  261,   -1,   -1,   -1,   -1,   -1,  267,  268,  269,
  270,  271,  272,  273,  274,  275,   -1,   -1,   -1,  279,
  280,  281,  282,  256,   -1,   -1,  259,  260,  261,   -1,
   -1,   -1,   -1,   -1,   -1,  268,  269,  270,  271,  272,
  273,  274,  275,   -1,   -1,  256,  279,  280,  281,  282,
  261,   -1,   -1,   -1,   -1,  266,   -1,  268,  269,  270,
  271,  272,  273,  274,  275,  256,   -1,   -1,  279,   -1,
  261,   -1,   -1,   -1,   -1,   -1,   -1,  268,  269,  270,
  271,  272,  273,  274,  275,  256,   -1,   -1,  279,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  268,  269,  270,
  271,  272,  273,  274,  275,  256,   -1,   -1,  279,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  268,  269,  270,
  271,  272,  273,  274,  275,  256,   -1,   -1,  279,   -1,
  261,   -1,   -1,   -1,   -1,   -1,   -1,  268,  269,  270,
  271,  272,  273,  274,  275,
};
#define YYFINAL 2
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 282
#if YYDEBUG
const char * const DbYYname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"OPEN_SQUARE","CLOSE_SQUARE",
"OPEN_BRACE","CLOSE_BRACE","OPEN_PAR","CLOSE_PAR","LOWER","GREATER","COMMA",
"EQUAL","SLASH","SHORT","INT","HEXA","FLOAT","DOUBLE","CHARACTER","STRING",
"REFERENCE","VERSION","NOVERSION","AT","NAME","TEXT","REAL","NUMBER",
};
const char * const DbYYrule[] = {
"$accept : db",
"db :",
"db : objects",
"objects : object",
"objects : objects object",
"object_name : NAME",
"object_name : object_name SLASH NAME",
"object : object_declaration",
"$$1 :",
"object : object_declaration EQUAL $$1 opt_value",
"opt_versioning :",
"opt_versioning : OPEN_PAR VERSION CLOSE_PAR",
"opt_versioning : OPEN_PAR NOVERSION CLOSE_PAR",
"opt_owner :",
"opt_owner : AT NAME",
"object_declaration : opt_versioning object_type object_name opt_owner",
"object_type : basic_type",
"object_type : set",
"object_type : error",
"basic_type : CHARACTER",
"basic_type : SHORT",
"basic_type : INT",
"basic_type : HEXA",
"basic_type : FLOAT",
"basic_type : DOUBLE",
"basic_type : STRING",
"basic_type : REFERENCE",
"basic_type : REFERENCE LOWER basic_type GREATER",
"basic_type : NAME",
"set : basic_type OPEN_SQUARE CLOSE_SQUARE",
"set : basic_type OPEN_SQUARE NUMBER CLOSE_SQUARE OPEN_SQUARE NUMBER CLOSE_SQUARE",
"set : basic_type OPEN_SQUARE REAL CLOSE_SQUARE OPEN_SQUARE REAL CLOSE_SQUARE",
"set : basic_type OPEN_SQUARE error CLOSE_SQUARE",
"opt_value :",
"opt_value : value",
"value : direct_value",
"value : keyed_value",
"direct_value : NUMBER",
"direct_value : REAL",
"direct_value : TEXT",
"direct_value : object_name",
"$$2 :",
"direct_value : OPEN_BRACE $$2 opt_values CLOSE_BRACE",
"direct_value : OPEN_BRACE error CLOSE_BRACE",
"$$3 :",
"keyed_value : NAME EQUAL $$3 direct_value",
"opt_values :",
"opt_values : values",
"values : value",
"values : values value",
};
#endif
#if YYDEBUG
#include <stdio.h>
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH 10000
#endif
#endif
#define YYINITSTACKSIZE 200
int DbYYdebug;
int DbYYnerrs;
int DbYYerrflag;
int DbYYchar;
short *DbYYssp;
YYSTYPE *DbYYvsp;
YYSTYPE DbYYval;
YYSTYPE DbYYlval;
short *DbYYss;
short *DbYYsslim;
YYSTYPE *DbYYvs;
int DbYYstacksize;

/*---------------------------------------------------------------*/
int DbYYwrap ()
/*---------------------------------------------------------------*/
{
  return (1);
}

/*---------------------------------------------------------------*/
static int DbLexicalError (char* s)
/*---------------------------------------------------------------*/
{
  int i;
  char* nl;
  char* start;
  int line_number;

  start = DbLexLineStart ();
  line_number = DbLexLineNumber ();

  nl = (char*) strchr (start, '\n');
  if (nl != NULL) *nl = 0;

  DbSetErrorInfo (DbErrorBadSyntax, 
                  "Db> %s at line %d :\nDb> %s\n", s, line_number, start);
  DbPrintError ();

  if (nl != NULL) *nl = '\n';

  return (1);
}

/*---------------------------------------------------------------*/
static DbObject DbObjectTextAnalyze (ParserMode mode, char* text, CLList list)
/*---------------------------------------------------------------*/
{
  ParserContext context;
  ParserContext* previous_context = Context;
  LexContext* previous_lex_context;
  LexContext lex_context;
  DbObject result = NULL;

  Context = &context;

  Context->mode          = mode;
  Context->first_object  = NULL;
  Context->object        = NULL;
  Context->type          = NULL;
  Context->type_iterator = NULL;
  Context->objects       = list;
  Context->name          = NULL;

  previous_lex_context = DbLexStartup (&lex_context, text);

  DbSemanticAnalyzer ();
  DbLexRestoreContext (previous_lex_context);

  if (Context->name != NULL)
    {
      free (Context->name);
      Context->name = NULL;
    }

  result = Context->first_object;

  Context = previous_context;

  return (result);
}

/*---------------------------------------------------------------*/
DbObject DbParserCreateObject (char* text)
/*---------------------------------------------------------------*/
{
  DbObject object;

  object = DbObjectTextAnalyze (ObjectHead, text, NULL);

  return (object);
}

/*---------------------------------------------------------------*/
void DbParserCreateObjects (char* text, CLList list)
/*---------------------------------------------------------------*/
{
  DbObjectTextAnalyze (ObjectHead, text, list);
}

/*---------------------------------------------------------------*/
DbObject DbParserLoadObjectCopy (char* text)
/*---------------------------------------------------------------*/
{
  DbObject object;

  object = DbObjectTextAnalyze (ObjectCopy, text, NULL);

  return (object);
}

/*---------------------------------------------------------------*/
void DbParserLoadObjectCopies (char* text, CLList list)
/*---------------------------------------------------------------*/
{
  DbObjectTextAnalyze (ObjectCopy, text, list);
}

/*---------------------------------------------------------------*/
static void ContextSetName (ParserContext* context, char* name)
/*---------------------------------------------------------------*/
{
  if (context->name != NULL) 
    {
      free (context->name);
      context->name = NULL;
    }

  if (name == NULL) return;
  if (strlen (name) == 0) return;
  
  context->name = (char*) malloc (strlen (name) + 1);
  strcpy (context->name, name);
}

/*---------------------------------------------------------------*/
static void ContextAppendName (ParserContext* context, char* name)
/*---------------------------------------------------------------*/
{
  if (name == NULL) return;
  if (strlen (name) == 0) return;
  
  context->name = (char*) realloc (
      context->name, 
      strlen (context->name) + 1 + strlen (name) + 1);
  strcat (context->name, "/");
  strcat (context->name, name);
}

/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int DbYYgrowstack()
{
    int newsize, i;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = DbYYstacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;
    i = DbYYssp - DbYYss;
    newss = DbYYss ? (short *)realloc(DbYYss, newsize * sizeof *newss) :
      (short *)malloc(newsize * sizeof *newss);
    if (newss == NULL)
        return -1;
    DbYYss = newss;
    DbYYssp = newss + i;
    newvs = DbYYvs ? (YYSTYPE *)realloc(DbYYvs, newsize * sizeof *newvs) :
      (YYSTYPE *)malloc(newsize * sizeof *newvs);
    if (newvs == NULL)
        return -1;
    DbYYvs = newvs;
    DbYYvsp = newvs + i;
    DbYYstacksize = newsize;
    DbYYsslim = DbYYss + newsize - 1;
    return 0;
}

#define YYABORT goto DbYYabort
#define YYREJECT goto DbYYabort
#define YYACCEPT goto DbYYaccept
#define YYERROR goto DbYYerrlab

#ifndef YYPARSE_PARAM
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG void
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif	/* ANSI-C/C++ */
#else	/* YYPARSE_PARAM */
#ifndef YYPARSE_PARAM_TYPE
#define YYPARSE_PARAM_TYPE void *
#endif
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG YYPARSE_PARAM_TYPE YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL YYPARSE_PARAM_TYPE YYPARSE_PARAM;
#endif	/* ANSI-C/C++ */
#endif	/* ! YYPARSE_PARAM */

int
DbYYparse (YYPARSE_PARAM_ARG)
    YYPARSE_PARAM_DECL
{
    register int DbYYm, DbYYn, DbYYstate;
#if YYDEBUG
    register const char *DbYYs;

    if ((DbYYs = getenv("YYDEBUG")))
    {
        DbYYn = *DbYYs;
        if (DbYYn >= '0' && DbYYn <= '9')
            DbYYdebug = DbYYn - '0';
    }
#endif

    DbYYnerrs = 0;
    DbYYerrflag = 0;
    DbYYchar = (-1);

    if (DbYYss == NULL && DbYYgrowstack()) goto DbYYoverflow;
    DbYYssp = DbYYss;
    DbYYvsp = DbYYvs;
    *DbYYssp = DbYYstate = 0;

DbYYloop:
    if ((DbYYn = DbYYdefred[DbYYstate])) goto DbYYreduce;
    if (DbYYchar < 0)
    {
        if ((DbYYchar = DbYYlex()) < 0) DbYYchar = 0;
#if YYDEBUG
        if (DbYYdebug)
        {
            DbYYs = 0;
            if (DbYYchar <= YYMAXTOKEN) DbYYs = DbYYname[DbYYchar];
            if (!DbYYs) DbYYs = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, DbYYstate, DbYYchar, DbYYs);
        }
#endif
    }
    if ((DbYYn = DbYYsindex[DbYYstate]) && (DbYYn += DbYYchar) >= 0 &&
            DbYYn <= YYTABLESIZE && DbYYcheck[DbYYn] == DbYYchar)
    {
#if YYDEBUG
        if (DbYYdebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, DbYYstate, DbYYtable[DbYYn]);
#endif
        if (DbYYssp >= DbYYsslim && DbYYgrowstack())
        {
            goto DbYYoverflow;
        }
        *++DbYYssp = DbYYstate = DbYYtable[DbYYn];
        *++DbYYvsp = DbYYlval;
        DbYYchar = (-1);
        if (DbYYerrflag > 0)  --DbYYerrflag;
        goto DbYYloop;
    }
    if ((DbYYn = DbYYrindex[DbYYstate]) && (DbYYn += DbYYchar) >= 0 &&
            DbYYn <= YYTABLESIZE && DbYYcheck[DbYYn] == DbYYchar)
    {
        DbYYn = DbYYtable[DbYYn];
        goto DbYYreduce;
    }
    if (DbYYerrflag) goto DbYYinrecovery;
#if defined(lint) || defined(__GNUC__)
    goto DbYYnewerror;
#endif
DbYYnewerror:
    DbYYerror("syntax error");
#if defined(lint) || defined(__GNUC__)
    goto DbYYerrlab;
#endif
DbYYerrlab:
    ++DbYYnerrs;
DbYYinrecovery:
    if (DbYYerrflag < 3)
    {
        DbYYerrflag = 3;
        for (;;)
        {
            if ((DbYYn = DbYYsindex[*DbYYssp]) && (DbYYn += YYERRCODE) >= 0 &&
                    DbYYn <= YYTABLESIZE && DbYYcheck[DbYYn] == YYERRCODE)
            {
#if YYDEBUG
                if (DbYYdebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *DbYYssp, DbYYtable[DbYYn]);
#endif
                if (DbYYssp >= DbYYsslim && DbYYgrowstack())
                {
                    goto DbYYoverflow;
                }
                *++DbYYssp = DbYYstate = DbYYtable[DbYYn];
                *++DbYYvsp = DbYYlval;
                goto DbYYloop;
            }
            else
            {
#if YYDEBUG
                if (DbYYdebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *DbYYssp);
#endif
                if (DbYYssp <= DbYYss) goto DbYYabort;
                --DbYYssp;
                --DbYYvsp;
            }
        }
    }
    else
    {
        if (DbYYchar == 0) goto DbYYabort;
#if YYDEBUG
        if (DbYYdebug)
        {
            DbYYs = 0;
            if (DbYYchar <= YYMAXTOKEN) DbYYs = DbYYname[DbYYchar];
            if (!DbYYs) DbYYs = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, DbYYstate, DbYYchar, DbYYs);
        }
#endif
        DbYYchar = (-1);
        goto DbYYloop;
    }
DbYYreduce:
#if YYDEBUG
    if (DbYYdebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, DbYYstate, DbYYn, DbYYrule[DbYYn]);
#endif
    DbYYm = DbYYlen[DbYYn];
    DbYYval = DbYYvsp[1-DbYYm];
    switch (DbYYn)
    {
case 2:
{
    }
break;
case 3:
{
      DbObject object = DbYYvsp[0].object;
      
      if ((Context->objects != NULL) && (object != NULL))
      {
        CLListAdd (Context->objects, object);
      }
      if (Context->first_object == NULL) Context->first_object = object;
    }
break;
case 4:
{
      DbObject object = DbYYvsp[0].object;
      
      if ((Context->objects != NULL) && (object != NULL))
      {
        CLListAdd (Context->objects, object);
      }
      if (Context->first_object == NULL) Context->first_object = object;
    }
break;
case 5:
{
      char* name = DbYYvsp[0].string;

      ContextSetName (Context, name);

      DbYYval.string = Context->name;
    }
break;
case 6:
{
      char* path = DbYYvsp[-2].string;
      char* name = DbYYvsp[0].string;

      ContextAppendName (Context, name);

      DbYYval.string = Context->name;
    }
break;
case 7:
{
      DbObject object = DbYYvsp[0].object;

      DbYYval.object = object;
    }
break;
case 8:
{
      DbObject object = DbYYvsp[-1].object;

      DbObjectClear (object);

      Context->type_iterator = DbObjectGiveOutputIterator (object);
    }
break;
case 9:
{
      DbTypeIteratorDelete (Context->type_iterator);
      Context->type_iterator = NULL;

      DbYYval.object = Context->object;
    }
break;
case 10:
{
      DbYYval.option = DbDefaultVersioning;
    }
break;
case 11:
{
      DbYYval.option = DbUseVersioning;
    }
break;
case 12:
{
      DbYYval.option = DbNoVersioning;
    }
break;
case 13:
{
      DbYYval.string = NULL;
    }
break;
case 14:
{
      char* name = DbYYvsp[0].string;

      DbYYval.string = name;
    }
break;
case 15:
{
      DbVersioningOption versioning = DbYYvsp[-3].option;
      DbType type = DbYYvsp[-2].type;
      char* name = DbYYvsp[-1].string;
      char* owner = DbYYvsp[0].string;

      DbObject object = NULL;
      char* path;
      char* slash;

      slash = strrchr (name, '/');
      if (slash == NULL) path = NULL;
      else
        {
          *slash = 0;
          path = name;
          name = slash + 1;
        }

      if ((Context->mode == ObjectHead) &&
          (type != NULL)) 
        {
          object = DbObjectFindInPath (name, path);
          if (object == NULL)
            {
              object = DbObjectNewInPath (type, name, path);
            }
        }

      if ((Context->mode == ObjectCopy) &&
          (type != NULL)) 
        {
          object = DbObjectNewInPath (type, name, path);
        }

      DbObjectSetVersioningOption (object, versioning);
      DbObjectSetOwner (object, owner);

      Context->object = object;
      
      DbYYval.object = object;
    }
break;
case 16:
{
      DbYYval.type = DbYYvsp[0].type;
    }
break;
case 17:
{
      DbYYval.type = DbYYvsp[0].type;
    }
break;
case 18:
{
      DbLexicalError ("Bad object type specification..");

      DbYYval.type = NULL;
    }
break;
case 19:
{
      DbYYval.type = DbTCharNew ();
    }
break;
case 20:
{
      DbYYval.type = DbTShortNew ();
    }
break;
case 21:
{
      DbYYval.type = DbTIntNew ();
    }
break;
case 22:
{
      DbYYval.type = DbTHexaNew ();
    }
break;
case 23:
{
      DbYYval.type = DbTFloatNew ();
    }
break;
case 24:
{
      DbYYval.type = DbTDoubleNew ();
    }
break;
case 25:
{
      DbYYval.type = DbTStringNew ();
    }
break;
case 26:
{
      DbYYval.type = DbTReferenceNew (NULL);
    }
break;
case 27:
{
      DbType type = DbYYvsp[-1].type;

      DbYYval.type = DbTReferenceNew (type);
    }
break;
case 28:
{
      char* name = DbYYvsp[0].string;
      DbType type;

      type = DbTStructureFind (name);

      if (type == NULL)
        {
            /*
              Unknown user type
              */
          DbSetErrorInfo (DbErrorUnloadedStructure, "%s", name);
        }

      DbYYval.type = type;
    }
break;
case 29:
{
      DbType type = DbYYvsp[-2].type;

      DbYYval.type = DbTVectorNew (type);
    }
break;
case 30:
{
      DbType type = DbYYvsp[-6].type;
      int rows = DbYYvsp[-4].number;
      int columns = DbYYvsp[-1].number;

      DbYYval.type = DbTMatrixNew (type, rows, columns);
    }
break;
case 31:
{
      DbType type = DbYYvsp[-6].type;
      int rows = (int) DbYYvsp[-4].real;
      int columns = (int) DbYYvsp[-1].real;

      DbYYval.type = DbTMatrixNew (type, rows, columns);
    }
break;
case 32:
{
      DbType type = DbYYvsp[-3].type;

      DbLexicalError ("Bad matrix specification");

      DbYYval.type = NULL;
    }
break;
case 37:
{
      int n = DbYYvsp[0].number;

      DbTypeIteratorStoreInt (Context->type_iterator, n);
      DbTypeIteratorForth (Context->type_iterator);
    }
break;
case 38:
{
      double d = DbYYvsp[0].real;

      DbTypeIteratorStoreDouble (Context->type_iterator, d);
      DbTypeIteratorForth (Context->type_iterator);
    }
break;
case 39:
{
      char* text = DbYYvsp[0].string;

      DbTypeIteratorStoreText (Context->type_iterator, text);
      DbTypeIteratorForth (Context->type_iterator);
    }
break;
case 40:
{
      char* text = DbYYvsp[0].string;

      DbTypeIteratorStoreName (Context->type_iterator, text);
      DbTypeIteratorForth (Context->type_iterator);
    }
break;
case 41:
{
      DbTypeIterator sub;

      sub = DbTypeIteratorDown (Context->type_iterator);

      Context->type_iterator = sub;
    }
break;
case 42:
{
      Context->type_iterator = DbTypeIteratorUp (Context->type_iterator);
      DbTypeIteratorForth (Context->type_iterator);
    }
break;
case 43:
{
      DbLexicalError ("Bad field value specification");
    }
break;
case 44:
{
      char* name = DbYYvsp[-1].string;

      DbTypeIteratorMoveTo (Context->type_iterator, name);
    }
break;
    }
    DbYYssp -= DbYYm;
    DbYYstate = *DbYYssp;
    DbYYvsp -= DbYYm;
    DbYYm = DbYYlhs[DbYYn];
    if (DbYYstate == 0 && DbYYm == 0)
    {
#if YYDEBUG
        if (DbYYdebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        DbYYstate = YYFINAL;
        *++DbYYssp = YYFINAL;
        *++DbYYvsp = DbYYval;
        if (DbYYchar < 0)
        {
            if ((DbYYchar = DbYYlex()) < 0) DbYYchar = 0;
#if YYDEBUG
            if (DbYYdebug)
            {
                DbYYs = 0;
                if (DbYYchar <= YYMAXTOKEN) DbYYs = DbYYname[DbYYchar];
                if (!DbYYs) DbYYs = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, DbYYchar, DbYYs);
            }
#endif
        }
        if (DbYYchar == 0) goto DbYYaccept;
        goto DbYYloop;
    }
    if ((DbYYn = DbYYgindex[DbYYm]) && (DbYYn += DbYYstate) >= 0 &&
            DbYYn <= YYTABLESIZE && DbYYcheck[DbYYn] == DbYYstate)
        DbYYstate = DbYYtable[DbYYn];
    else
        DbYYstate = DbYYdgoto[DbYYm];
#if YYDEBUG
    if (DbYYdebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *DbYYssp, DbYYstate);
#endif
    if (DbYYssp >= DbYYsslim && DbYYgrowstack())
    {
        goto DbYYoverflow;
    }
    *++DbYYssp = DbYYstate;
    *++DbYYvsp = DbYYval;
    goto DbYYloop;
DbYYoverflow:
    DbYYerror("yacc stack overflow");
DbYYabort:
    return (1);
DbYYaccept:
    return (0);
}
