#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "Db.h"
#include "CmMessage.h"

/*---------------------------------------------------------------*/
int main (int argc, char* argv[])
/*---------------------------------------------------------------*/
{
  DbString* db_str;
  char*     str;
  char      tag_name[128];
  char      value_name[1024];
  char      name[1024];

  
  if (argc > 2)
    {
      sprintf (value_name, "%s", argv[1]);
      sprintf (tag_name, "%s", argv[2]);
    }
  
  else
    {
      printf ("Two argument are expected: string_value tag_name \n");
      sprintf (tag_name, "%s", "new");
      sprintf (value_name, "%s", "2222");
    }

  if (!CmMessageOpenMultipleServer ("DbTString"))
    {
      fprintf (stderr, "Bad Cm connection\n");
      exit (0);
    }

  sprintf (name, "string Virgo/string_withversion = \"%s\"", value_name);

  DbCreateObject (name);

  
  if( DbGetError () == DbErrorOk)
    {
      printf ("Virgo/string_withversion creation OK \n");
    }
  else
    {
      printf ("Virgo/string_withversion creation NOT OK \n");
      exit (1);
    }

  DbTagObject ("Virgo/string_withversion", tag_name);


  db_str = DbStringObjectLoad ("Virgo/string_withversion");

  if( !(str = DbStringGetContents (db_str)) )
    {
      DbGetError ();
    }
  else
    {
      printf ("string_withversion: %s\n", str);
    }

  db_str = DbStringObjectLoadByTag ("Virgo/string_withversion", tag_name);

  if( !(str = DbStringGetContents (db_str)) )
    {
      DbGetError ();
    }
  else
    {
      printf ("string_withversion (tag=%s): %s\n", tag_name, str);
    }

  
  db_str = DbStringObjectLoadByTag ("Virgo/string_withversion", "test");

  if( !(str = DbStringGetContents (db_str)) )
    {
      DbGetError ();
    }
  else
    {
      printf ("string_withversion (tag=test): %s\n", str);
    }
  
  db_str = DbStringObjectLoadByTag ("Virgo/string_withversion", "other");

  if( !(str = DbStringGetContents (db_str)) )
    {
      DbGetError ();
    }
  else
    {
      printf ("string_withversion (tag=other): %s\n", str);
    }
  

  DbPrintError ();

  DbCleanup ();
  CmMessageCleanup ();
    /*
  GCDumpBase ();
  */

  return (0);
}
